// sent by php : cbb_data
cbb_data = cbb_data[0];
var cbb_banners = new Array();
jQuery(document).ready(function () {
    cbb_detectElementsToReplace();
    cbb_detectBanners();
});
function cbb_detectElementsToReplace(){
    jQuery.each(cbb_data.banners,function(){
        if(this.domElement != ""){
            if(jQuery(this.domElement).length>0){
                jQuery(this.domElement).html('').addClass('creative_banner').attr('data-id',this.id);
            }
        }
    });
    
}
function cbb_updateAIAssistant(){
    if(jQuery('.creative_banner[data-id] .cbb_aiAssistant').length>0){
        jQuery('#iaa_avatarPreviewContainer > div:not(#iaa_talkBubble),#iaa_avatarPreviewContainer > img').hide();
        jQuery('#iaa_avatarPreviewContainer').css({
              position: 'absolute',
               top: jQuery('.creative_banner[data-id] .cbb_aiAssistant').offset().top,
               left: jQuery('.creative_banner[data-id] .cbb_aiAssistant').offset().left,
               width: 0,
               marginLeft: 22,
               height: jQuery('.creative_banner[data-id] .cbb_aiAssistant').height()
        });        
        jQuery('#iaa_avatarPreviewContainer #iaa_talkBubble').css({
            bottom: jQuery('.creative_banner[data-id] .cbb_aiAssistant').height()+20
        });
    }    
}
function cbb_detectBanners(){
    jQuery('.creative_banner[data-id]:not(.cbb_ready)').each(function(){
        var banner = cbb_getBanner(jQuery(this).attr('data-id'));
        if(banner){
            jQuery(this).uniqueId();
            banner.divID = jQuery(this).attr('id');
            cbb_initBanner(banner);
        }
    });
}
function cbb_getBanner(bannerID){
    var rep = false;
    jQuery.each(cbb_data.banners,function(){
        if(this.id == bannerID){
            rep = this;
        }
    });
    return rep;
}
function cbb_initBanner(banner){
    var container =jQuery('#'+banner.divID);
    container.addClass('cbb_ready');
    banner.content = JSON.parse(banner.content);
    
    banner.mainCanvas = jQuery('<canvas id="'+banner.id+'_canvas" class="cbb_canvas"></canvas>');
    banner.depthCanvas = jQuery('<div id="'+banner.id+'_depthCanvas" class="cbb_depthCanvas"></div>');
    banner.bordersCanvas = jQuery('<canvas id="'+banner.id+'_bordersCanvas" class="cbb_bordersCanvas"></canvas>');
    banner.borderBottom = jQuery('<canvas id="'+banner.id+'_borderBottom" class="cbb_borderBottom"></canvas>');
    banner.borderTop = jQuery('<canvas id="'+banner.id+'_borderTop" class="cbb_borderTop"></canvas>');
    banner.borderLeft = jQuery('<canvas id="'+banner.id+'_borderLeft" class="cbb_borderLeft"></canvas>');
    banner.borderRight = jQuery('<canvas id="'+banner.id+'_borderRight" class="cbb_borderRight"></canvas>');
    
    container.append(banner.mainCanvas);
    container.append(banner.depthCanvas);
    container.append(banner.bordersCanvas);
    container.append(banner.borderBottom);
    container.append(banner.borderTop);
    container.append(banner.borderLeft);
    container.append(banner.borderRight);
    
    jQuery('#'+banner.id+'_canvas,#'+banner.id+'_depthCanvas,#'+banner.id+'_bordersCanvas').attr({
       width: container.parent().outerWidth(),
       height: banner.height
    });
    jQuery('#'+banner.id+'_depthCanvas,.creative_banner[data-id="'+banner.id+'"]').css({
        width: container.parent().outerWidth(),
        height: banner.height
    });
    jQuery(window).resize(function(){
        jQuery('#'+banner.id+'_canvas,#'+banner.id+'_depthCanvas,#'+banner.id+'_bordersCanvas').attr({
           width: container.parent().outerWidth()
        });
        jQuery('#'+banner.id+'_depthCanvas,.creative_banner[data-id="'+banner.id+'"]').css({
             width: container.parent().outerWidth()
        });
        cbb_updateBanner(banner);
    });
    
    banner.floorTextureImg = false;
    
    if(banner.content.floorTexture && banner.content.floorTexture != ""){
        banner.floorTextureImg = new Image();
        banner.floorTextureImg.onload = function() {
            cbb_updateBanner(banner);
        };
        banner.floorTextureImg.src = banner.content.floorTexture;
    }
    banner.ceilingTextureImg = false;
    if(banner.content.ceilingTexture && banner.content.ceilingTexture != ""){
        banner.ceilingTextureImg = new Image();
        banner.ceilingTextureImg.onload = function() {
            cbb_updateBanner(banner);
        };
        banner.ceilingTextureImg.src = banner.content.ceilingTexture;
    }
    banner.wallsTextureImg = false;
    if(banner.content.wallsTexture && banner.content.wallsTexture != ""){
        banner.wallsTextureImg = new Image();
        banner.wallsTextureImg.onload = function() {
            cbb_updateBanner(banner);
        };
        banner.wallsTextureImg.src = banner.content.wallsTexture;
    }
    banner.backgroundTextureImg = false;
    if(banner.content.backgroundTexture && banner.content.backgroundTexture != ""){
        banner.backgroundTextureImg = new Image();
        banner.backgroundTextureImg.onload = function() {
            cbb_updateBanner(banner);
        };
        banner.backgroundTextureImg.src = banner.content.backgroundTexture;
    }       
    
    
    banner.mainStage = new createjs.Stage(banner.id+'_canvas');
    banner.bordersStage = new createjs.Stage(banner.id+'_bordersCanvas');
    banner.backgroundShape = new createjs.Shape(); 
    banner.backgroundColorShape = new createjs.Shape(); 
    banner.wallShape = new createjs.Shape(); 
    banner.wallDepthShape = new createjs.Shape(); 
    banner.wallDepthColorShape = new createjs.Shape(); 
    banner.floorShape = new createjs.Shape(); 
    banner.floorDepthShape = new createjs.Shape(); 
    banner.floorDepthColorShape = new createjs.Shape(); 
    banner.ceilingShape = new createjs.Shape(); 
    banner.ceilingDepthShape = new createjs.Shape(); 
    banner.ceilingDepthColorShape = new createjs.Shape(); 
    banner.ceilingMaskShape = new createjs.Shape(); 
    banner.objectsDepthShape = new createjs.Shape(); 
        
    banner.mainStage.addChild(banner.backgroundShape);
    banner.mainStage.addChild(banner.backgroundColorShape);
    banner.bordersStage.addChild(banner.floorShape);
    banner.mainStage.addChild(banner.floorDepthShape);
    banner.mainStage.addChild(banner.floorDepthColorShape);
    banner.bordersStage.addChild(banner.ceilingShape);
    banner.mainStage.addChild(banner.ceilingDepthShape);
    banner.mainStage.addChild(banner.ceilingDepthColorShape);
    banner.bordersStage.addChild(banner.wallShape);
    banner.mainStage.addChild(banner.wallDepthShape);
    banner.mainStage.addChild(banner.wallDepthColorShape);
    banner.mainStage.addChild(banner.objectsDepthShape);  
    
    banner.objects = new Array();
    
    cbb_updateBanner(banner);
    
    if(banner.depthImg != ""){
        banner.depthCanvas.css({
            backgroundImage: 'url('+cbb_data.assetsUrl+'depthImgs/'+banner.depthImg+')'
        });
    }
        
    jQuery.each(banner.content.objects,function(){
       cbb_addNewObject(banner,this.file,this.animation,this);             
    });
        
}



function cbb_addNewObject(banner,file,animation,dataObj){
    var stageDiv = jQuery('<div class="cbb_objectStage"></div>');
    stageDiv.append('<img src="'+file+'" />');
    stageDiv.attr('data-file',file);
    stageDiv.attr('data-type',"");
    stageDiv.uniqueId();   
    
    jQuery('#'+banner.divID).append(stageDiv);
   
    var object = {
       id: stageDiv.prop('id'),
       animation: animation,
       animationImgs: new Array(),
       animationIndex:0,
       animationTimer: false,
       animationAlpha: 1,
       animationTimerIndex: 0,
       animationType: 'loop',
       file: file,
       isAIAssistant: false,
       indexObject: 90,
       points: new Array(),
       shadowEnabled: false,
       shadowAlpha: 50,
       shadowPosition: 0,
       shadowPositionY: 0,
       shape : null,
       shapeDepth:new createjs.Shape(),
       stageDiv: stageDiv,
       type: '',
       depth: 4,
       depthColor: '#273236',
       posMidX: banner.mainStage.canvas.width/2 - parseInt(stageDiv.css('left')),
       posMidY: banner.mainStage.canvas.height/2 - parseInt(stageDiv.css('top')),
       urlClick: ''
    };
    if(dataObj != null){
        jQuery.extend(object, dataObj); 
    }
    object.id = stageDiv.prop('id');
    object.animationImgs= new Array();
    banner.objects.push(object);
    
    object.stageDiv.attr('data-type',object.type);
    object.stageDiv.attr('data-file',object.file);
    cbb_initAnim(object);
    
    if(object.isAIAssistant){
        object.stageDiv.addClass('cbb_aiAssistant');
       // cbb_updateAIAssistant();
    }
    
    if(object.urlClick != ""){
        object.stageDiv.css({
           'cursor':'pointer' 
        });
        if(object.urlClick.substr(0,4) == "javascript:"){
            object.stageDiv.click(function(){
                eval(object.urlClick.substr(4,object.urlClick.length));
            });            
        }else {
            if(object.urlClick.substr(0,4) != "http"){
                object.urlClick = 'http://'+object.urlClick;
            }
            object.stageDiv.click(function(){
                document.location.href = object.urlClick;
            });            
        }
    }
    
    var img = new Image();
    img.onload = function(){      
        object.animationImgs.push(img);
        stageDiv.css({
           width:  img.naturalWidth,
           height: img.naturalHeight
        });
        
        if(dataObj == null){
            cbb_editObject({ target: object.stageDiv});
        }
        cbb_updateObjectsPosition(banner);
        
        // shadow
        if(object.shadowEnabled){
            var $shadow =jQuery('<div id="'+object.id+'_shadow" class="cbb_shadow"></div>');
            $shadow.css({
               width: object.stageDiv.width(), 
               height: object.stageDiv.height(),
               backgroundImage: 'url('+object.stageDiv.attr('data-file')+')',
               top: parseInt(object.stageDiv.css('top'))/*+(object.stageDiv.height()-2)*/,
               left: object.stageDiv.css('left')
            });
            object.stageDiv.after($shadow);
        }
        cbb_updateShadowObject(object,banner);
        
        object.stageDiv.css({
           zIndex: 90+object.indexObject 
        });        
        jQuery('#'+object.id+'_shadow').css({
           zIndex: parseInt(object.stageDiv.css('z-index'))-1
        });
        
        // anim 
        if(object.type == "animated"){
            object.animationIndex = 0;
            object.animationAlpha = 0;            
            object.spriteLoadIndex = 0;
            jQuery.each(object.animation.split('|'),function(i){
               var anim = this.split(';');         
               if(i>0){
                cbb_loadSpriteAnim(anim[0],i,object,banner);                   
               }
            });
        }
        
    };
    img.src = file;
    
    setTimeout(function(){cbb_updateObjectsPosition(banner);},200);
        
}

function cbb_updateShadowObject(object,banner){
    var posY= parseInt(object.stageDiv.css('top'));
    var shadowAlpha = parseFloat(object.shadowAlpha)/100;
     if(posY+object.stageDiv.height()>=banner.mainStage.canvas.height-(banner.content.floorHeight+banner.content.depth)){ 
         jQuery('#'+object.id+'_shadow').css({
            'opacity': shadowAlpha,
            'transform':'rotate(180deg) skewX('+object.shadowPosition+'deg) scaleX(-1)',
            top: parseInt(object.stageDiv.css('top')),
            left: object.stageDiv.css('left'),
            marginTop: 0,
            marginLeft:0,
            transformOrigin: 'bottom center'
        });
    } else if(posY<banner.content.ceilingHeight+banner.content.depth){ 
        jQuery('#'+object.id+'_shadow').css({
            'opacity': shadowAlpha,
            'transform':'rotate(180deg) skewX('+object.shadowPosition+'deg) scaleX(-1)',
            top: parseInt(object.stageDiv.css('top')),
            marginTop: 0,
            marginLeft: 0,
            left: object.stageDiv.css('left'),
            transformOrigin: 'top center'
        });
        
    } else {        
        jQuery('#'+object.id+'_shadow').css({
            'opacity': shadowAlpha,
            'transform':'none',
            top: parseInt(object.stageDiv.css('top')),
            left: object.stageDiv.css('left'),
            marginTop: object.shadowPositionY,
            marginLeft: object.shadowPosition,
            transformOrigin: 'bottom center'
        });
    }    
}

function cbb_updateObjectsPosition(banner){
   var chkDep = false;
  jQuery.each(banner.objects,function(){
    var object = this;
    if(object.stageDiv != null){
        object.stageDiv.css({
           left: banner.mainStage.canvas.width/2 - object.posMidX,
           top:  banner.mainStage.canvas.height/2 - object.posMidY
        });     
        cbb_updateShadowObject(object,banner);
        var chkHide = false;
        
        if(banner.content.wallsWidth>0 && object.stageDiv.position().left<banner.content.wallsWidth){
            chkDep = true;
        } else if(banner.content.wallsWidth>0 && (object.stageDiv.position().left+object.stageDiv.width())> jQuery('#'+banner.id+'_canvas').width() - banner.content.wallsWidth){ 
             
            chkDep = true;
        } else if(banner.content.originalWidth != "undefined" && banner.mainStage.canvas.width<banner.content.originalWidth && (object.stageDiv.position().left+object.stageDiv.width())> jQuery('#'+banner.id+'_canvas').width() - (parseInt(banner.content.wallsWidth)+parseInt(banner.content.depthX))){
            chkDep = true;           
        }else if(banner.content.originalWidth != "undefined" && banner.mainStage.canvas.width<banner.content.originalWidth && object.stageDiv.position().left< (parseInt(banner.content.wallsWidth)+parseInt(banner.content.depthX))){
            chkDep = true;           
        }
        if (chkHide){ 
            object.stageDiv.css({
                opacity: 0 
             });
             jQuery('#'+object.id+'_shadow').css({
                opacity: 0
             });
        } else {
            object.stageDiv.css({
                opacity: 1 
             });
             jQuery('#'+object.id+'_shadow').css({
                opacity: parseFloat(object.shadowAlpha)/100
             });
        }
    } 
  });
  if(chkDep){
      banner.chkDep = true;
  } else {
      banner.chkDep = false;      
  }
  // cbb_updateAIAssistant();
}

function cbb_initAnim(object){
     cbb_stopAnim(object);
     if(object.type == 'animated'){
        object.stageDiv.unbind('mouseenter mouseleave');
        if(object.animationType == "loopHover" || object.animationType == "hover"){        
           object.stageDiv.hover(function(){
               cbb_playAnimation(object);
           },function(){
                cbb_stopAnim(object);
           });
       } else if(object.animationType == "loop"){
           if(object.animation && object.animationImgs.length == object.animation.split('|').length){
               cbb_playAnimation(object);
           }        
       }
    }
}

function cbb_stopAnim(object){    
    if(object.animationTimer != false){
       clearTimeout(object.animationTimer);
    } 
    object.animationIndex = 0;
    object.animationAlpha = 0;
    object.stageDiv.children('img').stop().eq(0).css({opacity:1});
    object.stageDiv.children('img:not(:eq(0))').stop().css({opacity:0});
    
}
function cbb_loadSpriteAnim(image,index,object,banner){
     if(index >0){
     var $img = jQuery('<img src="'+image+'" class="cbb_objectAnimImg" />');
    $img.css({
       width: object.stageDiv.width(),
       height: object.stageDiv.height()                  
    });
        $img.css({opacity:0});
    }
    object.stageDiv.append($img);
    if(object.animationType == "loop"){
        object.spriteLoadIndex++;
         var animations = new Array(object.animation);
        if(object.animation.indexOf('|') >0){
            animations = object.animation.split('|');
        }
        if(object.spriteLoadIndex == animations.length-1){
            object.spriteLoadIndex = 0;
            object.animationIndex = 0;
            cbb_playAnimation(object);      
        }   
    }
}
function cbb_playAnimation(object){
    if(object != undefined && object.animation != undefined){
        var animations = new Array(object.animation);
        if(object.animation && object.animation.indexOf('|')>0) {
            animations =  object.animation.split('|');
        }           
       var mustStop = false;
       var currentAnim = animations[object.animationIndex];
       currentAnim = currentAnim.split(';'); 
       if(object.animationIndex == object.animation.split('|').length-1){
            object.animationIndex = 0;
            if(object.animationType == "hover"){
                mustStop = true;           
            }
        } else {
            object.animationIndex++;
        }
        var anim = animations[object.animationIndex];
        anim = anim.split(';');   
        if(anim.length>1 && object.type == "animated"){    
            var delay = currentAnim[1];        
            if(!mustStop){ 
                    object.animationTimer = setTimeout(function(){
                        if(object.animationIndex==0){
                            object.animationTimer1 =  setTimeout(function(){                            
                                object.stageDiv.children('img:not(:eq('+object.animationIndex+'))').animate({opacity:0},parseInt(anim[2]));
                            },parseInt(anim[2]));
                            object.stageDiv.children('img:eq('+object.animationIndex+')').animate({opacity:1},parseInt(anim[2]));
                        } else {        
                            setTimeout(function(){                            
                             object.stageDiv.children('img:not(:eq('+object.animationIndex+'))').animate({opacity:0},parseInt(anim[2]));
                            },parseInt(anim[2]));
                            object.stageDiv.children('img:eq('+object.animationIndex+')').animate({opacity:1},parseInt(anim[2]));                        
                        }

                        if(object.animationType != "hover"){
                              object.animationTimer = setTimeout(function(){
                                    cbb_playAnimation(object);
                            },anim[2]);
                        }      
                },delay);            
            }
        } else {
            object.stageDiv.children('img').eq(0).fadeIn(0);
            object.stageDiv.children('img:not(:eq(0))').fadeOut(0);
        }
    }
}

function cbb_fadeSprite(object){
    var animations = object.animation.split('|');
    var anim = animations[object.animationIndex];
        anim = anim.split(';'); 
    var previousIndex = object.animationIndex-1;
    var previousAnim = animations[previousIndex];
    if(previousIndex==0){
        previousAnim = new Array(object.file);        
    } else if(previousIndex<0){
        previousIndex= object.animation.split('|').length-1;
        previousAnim = animations[previousIndex].split(';');
    } else {
        previousAnim = previousAnim.split(';');
    }
    var currentImg =previousAnim[0];
    
    var data = {
        images: [previousAnim[0]],
        frames: {width:object.stage.canvas.width, height:object.stage.canvas.height}
    };
    if(anim[2] == 0){
        object.animationAlpha = 1;        
    } else {
        object.animationAlpha+=0.01;        
    }
    object.stage.removeAllChildren();
    var spreetsheet = new createjs.SpriteSheet(data);
    var shape = new createjs.Sprite(spreetsheet);
    shape.alpha = 1-object.animationAlpha;
    object.stage.addChild(shape);
    
    var data1 = {
        images: [anim[0]],
        frames: {width:object.stage.canvas.width, height:object.stage.canvas.height}
    };
    var spreetsheet1 = new createjs.SpriteSheet(data1);
    var shape1 = new createjs.Sprite(spreetsheet1);
    
    shape1.alpha = object.animationAlpha;
    object.stage.addChild(shape1);
    object.animationAlpha+=0.01;
    object.stage.update();   
    
    var delay = anim[2]/100;
    
    if( object.animationAlpha>=1){
         object.animationAlpha = 0;
         cbb_playAnimation(object);
    } else {
        object.animationTimer = setTimeout(function(){
            cbb_fadeSprite(object);
        },delay);
    }
}

function cbb_updateBanner(banner){
    var canvasWidth = jQuery('#'+banner.id+'_canvas').outerWidth();
    var canvasHeight =banner.height; 
    var wallWidth = banner.content.wallsWidth;
    cbb_updateObjectsPosition(banner);
    if(jQuery('#'+banner.id+'_canvas').outerWidth()<840 ||banner.chkDep){
        wallWidth = 0;
    }
  
  // Floor
  var color = banner.content.floorColor;
  var colorDepth = banner.content.floorColorDepth;
  var colorAlpha = banner.content.floorColorDepthAlpha/100;
  var hex = cbb_hexToRgb(colorDepth);
  var colorRgba = 'rgba('+hex.r+','+hex.g+','+hex.b+','+colorAlpha+')';
  var depth= banner.content.depth;
  var floorEndDepthX = 0;
  
  banner.borderBottom.css({height: banner.content.floorHeight,backgroundColor: color});
  
  banner.floorShape.graphics.clear();
  banner.floorDepthShape.graphics.clear();
  banner.floorShape.graphics.beginFill(color).drawRect(0,canvasHeight-banner.content.floorHeight,canvasWidth,banner.content.floorHeight).endFill();  
  banner.floorDepthShape.graphics.beginFill(colorDepth);    
  banner.floorDepthShape.graphics.moveTo(canvasWidth/2,canvasHeight/2);
  banner.floorDepthShape.graphics.lineTo(wallWidth,canvasHeight-banner.content.floorHeight);
  banner.floorDepthShape.graphics.lineTo(canvasWidth-wallWidth,canvasHeight-banner.content.floorHeight);
  for(var i=0;i<canvasWidth/2;i++){
      if(floorEndDepthX == 0 && banner.floorDepthShape.hitTest(i, canvasHeight-(banner.content.floorHeight+depth))){
          floorEndDepthX = i;
      }
  }
    if(wallWidth==0){
        floorEndDepthX = 0;
    }
  
  banner.floorDepthShape.graphics.clear();
  if(!banner.floorTextureImg || !cbb_isImageOk(banner.floorTextureImg)){    
      
  } else {
    banner.floorDepthShape.graphics.beginBitmapFill(banner.floorTextureImg,'repeat');   
    if(wallWidth == 0){     
        banner.floorDepthShape.graphics.moveTo(floorEndDepthX,canvasHeight-(banner.content.floorHeight+depth));
        banner.floorDepthShape.graphics.lineTo(canvasWidth-(floorEndDepthX),canvasHeight-(banner.content.floorHeight+depth));
        banner.floorDepthShape.graphics.lineTo(canvasWidth-(wallWidth),canvasHeight-(banner.content.floorHeight));   
        banner.floorDepthShape.graphics.lineTo(wallWidth,canvasHeight-(banner.content.floorHeight));       
    } else {
        banner.floorDepthShape.graphics.moveTo(floorEndDepthX-1,canvasHeight-(banner.content.floorHeight+depth));
        banner.floorDepthShape.graphics.lineTo(canvasWidth-(floorEndDepthX-1),canvasHeight-(banner.content.floorHeight+depth));
        banner.floorDepthShape.graphics.lineTo(canvasWidth-(wallWidth+1),canvasHeight-(banner.content.floorHeight+1));   
        banner.floorDepthShape.graphics.lineTo(canvasWidth-(wallWidth+1),canvasHeight-(banner.content.floorHeight));   
        banner.floorDepthShape.graphics.lineTo(wallWidth+1,canvasHeight-(banner.content.floorHeight));   
        banner.floorDepthShape.graphics.lineTo(wallWidth+1,canvasHeight-(banner.content.floorHeight+1));         
    }
  }

    // color shape
    banner.floorDepthColorShape.graphics.clear();
    banner.floorDepthColorShape.graphics.beginFill(colorRgba);    
    if(wallWidth == 0){    
        banner.floorDepthColorShape.graphics.moveTo(floorEndDepthX,canvasHeight-(banner.content.floorHeight+depth));
        banner.floorDepthColorShape.graphics.lineTo(canvasWidth-(floorEndDepthX),canvasHeight-(banner.content.floorHeight+depth));
        banner.floorDepthColorShape.graphics.lineTo(canvasWidth-(wallWidth),canvasHeight-(banner.content.floorHeight));
        banner.floorDepthColorShape.graphics.lineTo(wallWidth,canvasHeight-(banner.content.floorHeight));
    } else {
        banner.floorDepthColorShape.graphics.moveTo(floorEndDepthX-1,canvasHeight-(banner.content.floorHeight+depth));
        banner.floorDepthColorShape.graphics.lineTo(canvasWidth-(floorEndDepthX-1),canvasHeight-(banner.content.floorHeight+depth));
        banner.floorDepthColorShape.graphics.lineTo(canvasWidth-(wallWidth+1),canvasHeight-(banner.content.floorHeight+1));
        banner.floorDepthColorShape.graphics.lineTo(canvasWidth-(wallWidth+1),canvasHeight-(banner.content.floorHeight));
        banner.floorDepthColorShape.graphics.lineTo(wallWidth+1,canvasHeight-(banner.content.floorHeight));
        banner.floorDepthColorShape.graphics.lineTo(wallWidth+1,canvasHeight-(banner.content.floorHeight+1));
        
    }
    
    // ceiling  
  color = banner.content.ceilingColor;
  colorDepth = banner.content.ceilingColorDepth;
  hex = cbb_hexToRgb(colorDepth);
  colorAlpha = banner.content.ceilingColorDepthAlpha/100;
  colorRgba = 'rgba('+hex.r+','+hex.g+','+hex.b+','+colorAlpha+')';
  
  banner.borderTop.css({height: banner.content.ceilingHeight,backgroundColor: color});
  
  banner.ceilingShape.graphics.clear();
  banner.ceilingDepthShape.graphics.clear();
  if(banner.content.ceilingHeight>0 || wallWidth >0){
    banner.ceilingShape.graphics.beginFill(color).drawRect(0,0,canvasWidth,banner.content.ceilingHeight);  
    banner.ceilingDepthShape.graphics.beginFill(colorDepth); 
    banner.ceilingDepthShape.graphics.moveTo(canvasWidth/2,canvasHeight/2);
    banner.ceilingDepthShape.graphics.lineTo(wallWidth,banner.content.ceilingHeight);
    banner.ceilingDepthShape.graphics.lineTo(canvasWidth-wallWidth,banner.content.ceilingHeight);
    banner.ceilingDepthShape.graphics.clear();
    if(!banner.ceilingTextureImg || !cbb_isImageOk(banner.ceilingTextureImg)){          
    } else {
      banner.ceilingDepthShape.graphics.beginBitmapFill(banner.ceilingTextureImg,'repeat');  

      if(wallWidth == 0){    
          banner.ceilingDepthShape.graphics.moveTo(floorEndDepthX,banner.content.ceilingHeight+(depth));
          banner.ceilingDepthShape.graphics.lineTo(wallWidth,banner.content.ceilingHeight);
          banner.ceilingDepthShape.graphics.lineTo(canvasWidth-(wallWidth),banner.content.ceilingHeight);
          banner.ceilingDepthShape.graphics.lineTo(canvasWidth-(floorEndDepthX),banner.content.ceilingHeight+depth); 
      } else {
          banner.ceilingDepthShape.graphics.moveTo(floorEndDepthX-1,banner.content.ceilingHeight+(depth));
          banner.ceilingDepthShape.graphics.lineTo(wallWidth-1,banner.content.ceilingHeight+1);
          banner.ceilingDepthShape.graphics.lineTo(wallWidth-1,banner.content.ceilingHeight);
          banner.ceilingDepthShape.graphics.lineTo(canvasWidth-(wallWidth-1),banner.content.ceilingHeight);
          banner.ceilingDepthShape.graphics.lineTo(canvasWidth-(wallWidth-1),banner.content.ceilingHeight+1);
          banner.ceilingDepthShape.graphics.lineTo(canvasWidth-(floorEndDepthX-1),banner.content.ceilingHeight+depth);        
      }
    }
      banner.ceilingDepthColorShape.graphics.clear();
      banner.ceilingDepthColorShape.graphics.beginFill(colorRgba); 
      if(wallWidth == 0){   
          banner.ceilingDepthColorShape.graphics.moveTo(floorEndDepthX,banner.content.ceilingHeight+(depth));
          banner.ceilingDepthColorShape.graphics.lineTo(wallWidth,banner.content.ceilingHeight);
          banner.ceilingDepthColorShape.graphics.lineTo(canvasWidth-(wallWidth),banner.content.ceilingHeight);
          banner.ceilingDepthColorShape.graphics.lineTo(canvasWidth-(floorEndDepthX),banner.content.ceilingHeight+depth);        
      } else {
          banner.ceilingDepthColorShape.graphics.moveTo(floorEndDepthX-1,banner.content.ceilingHeight+(depth));
          banner.ceilingDepthColorShape.graphics.lineTo(wallWidth-1,banner.content.ceilingHeight+1);
          banner.ceilingDepthColorShape.graphics.lineTo(wallWidth-1,banner.content.ceilingHeight);
          banner.ceilingDepthColorShape.graphics.lineTo(canvasWidth-(wallWidth-1),banner.content.ceilingHeight);
          banner.ceilingDepthColorShape.graphics.lineTo(canvasWidth-(wallWidth-1),banner.content.ceilingHeight+1);
          banner.ceilingDepthColorShape.graphics.lineTo(canvasWidth-(floorEndDepthX-1),banner.content.ceilingHeight+depth);
      }
  }
  
    // walls    
    banner.wallShape.graphics.clear();
    banner.wallDepthShape.graphics.clear();
    banner.wallDepthColorShape.graphics.clear();
    
    color = banner.content.wallsColor;
    
    banner.borderLeft.css({width: wallWidth,backgroundColor: color});
    banner.borderRight.css({width: wallWidth,backgroundColor: color});
  
    if(wallWidth>0){
        colorDepth = banner.content.wallsColorDepth;
        hex = cbb_hexToRgb(colorDepth);
        colorAlpha = banner.content.wallsColorDepthAlpha/100;
        colorRgba = 'rgba('+hex.r+','+hex.g+','+hex.b+','+colorAlpha+')';
        banner.wallShape.graphics.beginFill(color).drawRect(0,banner.content.ceilingHeight,wallWidth,canvasHeight-(banner.content.ceilingHeight+banner.content.floorHeight));  
        banner.wallShape.graphics.beginFill(color).drawRect(canvasWidth-wallWidth,banner.content.ceilingHeight,wallWidth,canvasHeight-(banner.content.ceilingHeight+banner.content.floorHeight));  
        banner.wallDepthShape.graphics.beginFill(colorDepth).moveTo(wallWidth,banner.content.ceilingHeight);
        banner.wallDepthShape.graphics.lineTo(floorEndDepthX,banner.content.ceilingHeight+depth);  
        banner.wallDepthShape.graphics.lineTo(floorEndDepthX,canvasHeight-(banner.content.floorHeight+depth));  
        banner.wallDepthShape.graphics.lineTo(wallWidth,canvasHeight-banner.content.floorHeight);
        banner.wallDepthShape.graphics.endFill();  
        banner.wallDepthShape.graphics.beginFill(colorDepth).moveTo(canvasWidth-wallWidth,banner.content.ceilingHeight);  
        banner.wallDepthShape.graphics.lineTo(canvasWidth-floorEndDepthX,banner.content.ceilingHeight+depth);  
        banner.wallDepthShape.graphics.lineTo(canvasWidth-floorEndDepthX,canvasHeight-(banner.content.floorHeight+depth));  
        banner.wallDepthShape.graphics.lineTo(canvasWidth-wallWidth,canvasHeight-banner.content.floorHeight);
        banner.wallDepthShape.graphics.clear();

        if(!banner.wallsTextureImg|| !cbb_isImageOk(banner.wallsTextureImg)){

        }else{
          banner.wallDepthShape.graphics.beginBitmapFill(banner.wallsTextureImg,'repeat'); 
          banner.wallDepthShape.graphics.moveTo(wallWidth,banner.content.ceilingHeight);
          banner.wallDepthShape.graphics.lineTo(floorEndDepthX,banner.content.ceilingHeight+depth);  
          banner.wallDepthShape.graphics.lineTo(floorEndDepthX,canvasHeight-(banner.content.floorHeight+depth));  
          banner.wallDepthShape.graphics.lineTo(wallWidth,canvasHeight-banner.content.floorHeight);
          banner.wallDepthShape.graphics.endFill();  
          banner.wallDepthShape.graphics.beginBitmapFill(banner.wallsTextureImg,'repeat'); 
          banner.wallDepthShape.graphics.moveTo(canvasWidth-wallWidth,banner.content.ceilingHeight);  
          banner.wallDepthShape.graphics.lineTo(canvasWidth-floorEndDepthX,banner.content.ceilingHeight+depth);  
          banner.wallDepthShape.graphics.lineTo(canvasWidth-floorEndDepthX,canvasHeight-(banner.content.floorHeight+depth));  
          banner.wallDepthShape.graphics.lineTo(canvasWidth-wallWidth,canvasHeight-banner.content.floorHeight);
        }

        banner.wallDepthColorShape.graphics.beginFill(colorRgba).moveTo(wallWidth,banner.content.ceilingHeight);
        banner.wallDepthColorShape.graphics.lineTo(floorEndDepthX,banner.content.ceilingHeight+depth);  
        banner.wallDepthColorShape.graphics.lineTo(floorEndDepthX,canvasHeight-(banner.content.floorHeight+depth));  
        banner.wallDepthColorShape.graphics.lineTo(wallWidth,canvasHeight-banner.content.floorHeight);
        banner.wallDepthColorShape.graphics.endFill();  
        banner.wallDepthColorShape.graphics.beginFill(colorRgba).moveTo(canvasWidth-wallWidth,banner.content.ceilingHeight);  
        banner.wallDepthColorShape.graphics.lineTo(canvasWidth-floorEndDepthX,banner.content.ceilingHeight+depth);  
        banner.wallDepthColorShape.graphics.lineTo(canvasWidth-floorEndDepthX,canvasHeight-(banner.content.floorHeight+depth));  
        banner.wallDepthColorShape.graphics.lineTo(canvasWidth-wallWidth,canvasHeight-banner.content.floorHeight);

  }
  
  // background
  banner.backgroundShape.graphics.clear();
  var color = banner.content.backgroundColor;
  var colorAlpha =  banner.content.backgroundAlpha/100;
  var hex = cbb_hexToRgb(color);
  var colorRgba = 'rgba('+hex.r+','+hex.g+','+hex.b+','+colorAlpha+')';
     
  var posY1 = banner.content.ceilingHeight+depth;
  var posY2 = canvasHeight-(banner.content.floorHeight+banner.content.ceilingHeight+depth*2);
  if(!banner.backgroundTextureImg|| !cbb_isImageOk(banner.backgroundTextureImg)){     
  } else {
    var m = new createjs.Matrix2D;
    var posX = 0;
    var posY = 0;
    if(banner.backgroundTextureImg.height > canvasHeight) {
        posY = 0-(banner.backgroundTextureImg.height/2-canvasHeight/2)
    }
    if(banner.backgroundTextureImg.width > canvasHeight) {
        posX = 0-(banner.backgroundTextureImg.width/2-canvasWidth/2)
    }
    m.translate(posX, canvasHeight);
    banner.backgroundShape.graphics.beginBitmapFill(banner.backgroundTextureImg,'repeat',m);   
    if(banner.content.ceilingHeight == 0){
        posY1 = 0;
    }
    var posY2 = canvasHeight-(banner.content.floorHeight+banner.content.ceilingHeight+depth*2);
    if(banner.content.ceilingHeight == 0){
        posY2 = canvasHeight-(banner.content.floorHeight+banner.content.ceilingHeight+depth);
    }     
    banner.backgroundShape.graphics.drawRect(floorEndDepthX,posY1,canvasWidth-floorEndDepthX*2,posY2).endFill();        
  }
  banner.backgroundColorShape.graphics.clear();
  banner.backgroundColorShape.graphics.beginFill(colorRgba).drawRect(floorEndDepthX,posY1,canvasWidth-floorEndDepthX*2,posY2).endFill();  
   
  banner.mainStage.update();
  banner.bordersStage.update();
}


function cbb_isImageOk(img) {
    if (!img.complete) {
        return false;
    }
    if (typeof img.naturalWidth !== "undefined" && img.naturalWidth === 0) {
        return false;
    }
    return true;
}

function cbb_hexToRgb(hex) {
    var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
    return result ? {
        r: parseInt(result[1], 16),
        g: parseInt(result[2], 16),
        b: parseInt(result[3], 16)
    } : null;
}